# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: user.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import datetime
from typing import Optional

import betterproto
import grpclib

from . import common


@dataclass
class User(betterproto.Message):
    id: int = betterproto.int32_field(1)
    username: str = betterproto.string_field(2)
    last_update: datetime = betterproto.message_field(3)
    is_test: bool = betterproto.bool_field(4)


@dataclass
class GetUserCall(betterproto.Message):
    user: common.UserId = betterproto.message_field(1)


@dataclass
class GetUserResponse(betterproto.Message):
    user: "User" = betterproto.message_field(1)


@dataclass
class UserServiceCall(betterproto.Message):
    get_user_call: "GetUserCall" = betterproto.message_field(1, group="message")


@dataclass
class UserServiceResponse(betterproto.Message):
    get_user_response: "GetUserResponse" = betterproto.message_field(1, group="message")


class UserControllerStub(betterproto.ServiceStub):
    async def get_user(self) -> User:
        request = common.UserId()

        return await self._unary_unary(
            "/user.UserController/GetUser",
            request,
            User,
        )

    async def add_test_user(
        self,
        *,
        id: int = 0,
        username: str = "",
        last_update: Optional[datetime] = None,
        is_test: bool = False,
    ) -> User:
        request = User()
        request.id = id
        request.username = username
        if last_update is not None:
            request.last_update = last_update
        request.is_test = is_test

        return await self._unary_unary(
            "/user.UserController/AddTestUser",
            request,
            User,
        )

    async def add_user(
        self,
        *,
        id: int = 0,
        username: str = "",
        last_update: Optional[datetime] = None,
        is_test: bool = False,
    ) -> common.UserId:
        request = User()
        request.id = id
        request.username = username
        if last_update is not None:
            request.last_update = last_update
        request.is_test = is_test

        return await self._unary_unary(
            "/user.UserController/AddUser",
            request,
            common.UserId,
        )
